Attribute VB_Name = "Module3"
Option Explicit
Private Month_Name, Spring_Fall
Private Time_Difference, Time_Client
Private Base_Year
Private Declare Function InitCommonControlsEx Lib "comctl32.dll" (iccex As tagInitCommonControlsEx) As Boolean
Public Const ICC_USEREX_CLASSES = &H200
Public Const BIF_RETURNONLYFSDIRS = 1
Public Const MAX_PATH = 260
Private Type tagInitCommonControlsEx
   lngSize As Long
   lngICC As Long
End Type
Private Const hezar = " "
Private Const melun = " "
Private Const melyard = " "
Private Const va = "  "
Public Function InitCommonControlsVB() As Boolean
   On Error Resume Next
   Dim iccex As tagInitCommonControlsEx
   With iccex
       .lngSize = LenB(iccex)
       .lngICC = ICC_USEREX_CLASSES
   End With
   InitCommonControlsEx iccex
   InitCommonControlsVB = (Err.Number = 0)
   On Error GoTo 0
End Function
Private Sub Get_Date(ByVal Days, Sal, Mah, Rooz)
   Dim Years, Year_Length
   Do While Days >= 0
     If Kabiseh(Years) Then
        Year_Length = 366
     Else
        Year_Length = 365
     End If
     If Days - Year_Length >= 0 Then
        Years = Years + 1
        Days = Days - Year_Length
     Else
        Sal = Base_Year + Years
        If Days <= 185 Then
           Mah = 1 + (Days \ 31)
           Rooz = 1 + (Days Mod 31)
        Else
           Days = Days - 186
           Mah = 7 + (Days \ 30)
           Rooz = 1 + (Days Mod 30)
        End If
        Exit Sub
     End If
   Loop
End Sub
Private Function Kabiseh(ByVal Years)
   Dim Temp
   Kabiseh = False
   Temp = (Base_Year + Years) - 1309
   If (((Temp Mod 32) - (Temp \ 32)) Mod 4) = 0 Then Kabiseh = True
End Function
Public Property Let SFhour(X)
   Spring_Fall = X
End Property
Public Property Let Time_Diff(ByVal t)
   Time_Difference = t
End Property
Public Property Let state(ByVal S)
   Month_Name = S
End Property
Public Function To_Hejri(ByVal what_date, Optional Month_Name)
   Dim Days, Day_Name, Day_Number, Temp_Days, Months
   Spring_Fall = False
   If IsMissing(Month_Name) Then Month_Name = 0

   Time_Difference = #12:00:00 AM#
   Base_Year = 1332

   Months = Array("", "", "", "", "", "", "", "", "", "", "", "")

   Day_Name = Array("", "", " ", "", "", "", "")
   Days = DateDiff("d", #3/21/1953#, what_date)
   Day_Number = Weekday(what_date)
   Dim Year_Length, Sal, Mah, Rooz, temp_date
   If FormatDateTime(what_date + Time_Difference, vbShortDate) <> FormatDateTime(what_date, vbShortDate) Then
      Days = Days + 1
      Day_Number = (Day_Number + 1)
      If Day_Number = 8 Then Day_Number = 1
   End If
   Time_Client = FormatDateTime(what_date + Time_Difference, vbLongTime)
   Call Get_Date(Days, Sal, Mah, Rooz)
   If ((Mah >= 1 And Mah <= 6) And Not ((Mah = 1 And Rooz = 1) Or (Mah = 6 And Rooz = 31))) And Spring_Fall = True Then
      If FormatDateTime(what_date + Time_Difference + #1:00:00 AM#, vbShortDate) <> FormatDateTime(what_date + Time_Difference, vbShortDate) Then
         Temp_Days = Days + 1
         Day_Number = (Day_Number + 1)
         If Day_Number = 8 Then Day_Number = 1
      Else
         Temp_Days = Days
      End If
      Time_Client = FormatDateTime(what_date + Time_Difference + #1:00:00 AM#, vbLongTime)
      If Temp_Days <> Days Then
         Days = Temp_Days
         If Rooz = 30 And Mah = 6 Then
            If DateDiff("n", Time_Client, #1:00:00 AM#) <= 60 And DateDiff("n", Time_Client, #1:00:00 AM#) >= 0 Then
               Time_Client = FormatDateTime(what_date + Time_Difference, vbLongTime)
               Days = Days - 1
               If Day_Number = 1 Then
                  Day_Number = 7
               Else
                  Day_Number = Day_Number - 1
               End If
            End If
         End If
         Call Get_Date(Days, Sal, Mah, Rooz)
      End If
   End If
   If Month_Name = 0 Then
      If Rooz < 10 Then Rooz = "0" & Rooz
      If Mah < 10 Then Mah = "0" & Mah
      To_Hejri = Sal & "/" & Mah & "/" & Rooz
   ElseIf Month_Name = 1 Then
      To_Hejri = Rooz & " " & Months(Mah - 1) & " " & Sal
   ElseIf Month_Name = 2 Then
      To_Hejri = Day_Name(Day_Number - 1) & " " & Rooz & "/" & Mah & "/" & Sal
   ElseIf Month_Name = 3 Then
      To_Hejri = Day_Name(Day_Number - 1) & "  " & Rooz & "  " & Months(Mah - 1) & "  " & Sal
   End If
End Function
Public Function To_Time(what_date)
   Call To_Hejri(what_date)
   To_Time = Time_Client
End Function
Private Sub Class_Initialize()
   Spring_Fall = False
   Month_Name = 0
   Time_Difference = #12:00:00 AM#
   Base_Year = 1332
End Sub

'--- Farsi Number Convertor ------------------'

Public Function heji_adad(ByVal adad As Double) As String
    Dim hooroof As String
    Dim ss As Integer  'sadgan
    Dim hh As Integer   'hezargan
    Dim mm As Integer  'melungan
    Dim yy As Integer   'melyardgan
    Dim STRadad As String
    Dim LENadad As Integer
    
    STRadad = Str(Val(Str(adad)))
    LENadad = Len(STRadad)
    
    Select Case adad
                    Case Is = 0
                                    hooroof = ""
                    Case 1 To 999
                                       hooroof = Adad_Heji(adad)
    
                    Case 1000 To 999999
    
                                If (adad Mod 1000 = 0) Then hooroof = Adad_Heji(Int(adad / 1000)) + hezar
                                If (adad Mod 1000 <> 0) Then hooroof = Adad_Heji(Int(adad / 1000)) + hezar + va + (Adad_Heji(adad Mod 1000))
    
                    Case 1000000 To 999999999
    
                    ss = Val(Right$(STRadad, 3))
                     hh = Val(Mid$(STRadad, LENadad - 5, 3))
                     mm = Val(Left$(STRadad, LENadad - 6))
    
                   If (ss = 0 And hh = 0) Then hooroof = Adad_Heji(mm) + melun
                   If (ss = 0 And hh <> 0) Then hooroof = Adad_Heji(mm) + melun + va + Adad_Heji(hh) + hezar
                   If (ss <> 0 And hh = 0) Then hooroof = Adad_Heji(mm) + melun + va + Adad_Heji(ss)
                   If (ss <> 0 And hh <> 0) Then hooroof = Adad_Heji(mm) + melun + va + Adad_Heji(hh) + hezar + va + Adad_Heji(ss)
    
                   Case 1000000000 To 999999999999#
    
                           ss = Val(Right$(STRadad, 3))
                           hh = Val(Mid$(STRadad, LENadad - 5, 3))
                           mm = Val(Mid$(STRadad, LENadad - 8, 3))
                           yy = Val(Left$(STRadad, LENadad - 9))
    
                                If (ss = 0 And hh = 0 And mm = 0) Then hooroof = Adad_Heji(yy) + melyard
                                If (ss = 0 And hh = 0 And mm <> 0) Then hooroof = Adad_Heji(yy) + melyard + va + Adad_Heji(mm) + melun
                                If (ss = 0 And hh <> 0 And mm <> 0) Then hooroof = Adad_Heji(yy) + melyard + va + Adad_Heji(mm) + melun + va + Adad_Heji(hh) + hezar
                                If (ss <> 0 And hh <> 0 And mm <> 0) Then hooroof = Adad_Heji(yy) + melyard + va + Adad_Heji(mm) + melun + va + Adad_Heji(hh) + hezar + va + Adad_Heji(ss)
    
                       Case Is > 999999999999#
                                   hooroof = "        "
    
        End Select
        
       heji_adad = hooroof
End Function

Private Function Adad_Heji(ByVal adad As Integer) As String
    Dim yekan As Byte
    Dim dahgan As Byte
    Dim sadgan As Byte
    Dim behooroof As String
    
    Dim heji(19) As String
    Dim heji_dahgan(9) As String
    Dim heji_sadgan(9) As String
    '-------------------------------
    heji(1) = "": heji(2) = "": heji(3) = "": heji(4) = "": heji(5) = ""
    heji(6) = "": heji(7) = "": heji(8) = "": heji(9) = "": heji(10) = ""
    heji(11) = "": heji(12) = "": heji(13) = "": heji(14) = "": heji(15) = ""
    heji(16) = "": heji(17) = "": heji(18) = "": heji(19) = ""
    '-------------------------------
    heji_dahgan(1) = ""
    heji_dahgan(2) = ""
    heji_dahgan(3) = "": heji_dahgan(4) = "": heji_dahgan(5) = " "
    heji_dahgan(6) = "": heji_dahgan(7) = "": heji_dahgan(8) = ""
    heji_dahgan(9) = ""
    '------------------------
    heji_sadgan(1) = "": heji_sadgan(2) = "": heji_sadgan(3) = ""
    heji_sadgan(4) = "": heji_sadgan(5) = "": heji_sadgan(6) = ""
    heji_sadgan(7) = "": heji_sadgan(8) = "": heji_sadgan(9) = ""
    '------------------------------------------------------------------------------------------------------------
             yekan = adad Mod 10
            dahgan = adad Mod 100
            sadgan = Int(adad / 100)
    '------------------------------------------------------------------------------------------------------------
            If dahgan < 20 Then
    
                        If (sadgan = 0) Then behooroof = heji(dahgan)
                        If (sadgan <> 0) Then behooroof = heji_sadgan(sadgan) + va + heji(dahgan)
                        If (yekan = 0 And dahgan = 0) Then behooroof = heji_sadgan(sadgan)
    
            Else
                dahgan = (adad Mod 100) - yekan
    
                           If (sadgan = 0 And yekan = 0) Then behooroof = heji_dahgan(dahgan / 10)
                           If (sadgan = 0 And yekan <> 0) Then behooroof = heji_dahgan(dahgan / 10) + va + heji(yekan)
                           If (sadgan <> 0 And yekan = 0) Then behooroof = heji_sadgan(sadgan) + va + heji_dahgan(dahgan / 10)
                           If (sadgan <> 0 And yekan <> 0) Then behooroof = heji_sadgan(sadgan) + va + heji_dahgan(dahgan / 10) + va + heji(yekan)
    
            End If
    
    Adad_Heji = behooroof
End Function

Private Function change_mony(ByVal Pol As Currency) As String
    Dim P As String, P1 As String
    Dim P2 As String, P3 As String
    Dim P4 As String, Sk As String
    Dim L As Byte
    If Pol > 0 Then
              P = Str(Pol)
              Sk = Right(Trim(P), 3)
              P1 = harf(Val(Trim(Sk)))
              P1 = Trim(P1) & " "
              If Len(Trim(P)) > 3 Then
                       Sk = Right(Trim(P), 6)
                       L = Len(Trim(Sk))
                       Sk = Left(Trim(Sk), (L - 3))
                       P2 = harf(Val(Trim(Sk)))
                       P2 = Trim(P2) & "   "
              End If
              If Len(Trim(P)) > 6 Then
                       Sk = Right(Trim(P), 9)
                       L = Len(Trim(Sk))
                       Sk = Left(Trim(Sk), (L - 6))
                       P3 = harf(Val(Trim(Sk)))
                       P3 = Trim(P3) & "  "
              End If
              If Len(Trim(P)) = 10 Then
                       Sk = Left(Trim(P), 1)
                       P4 = harf(Val(Trim(Sk)))
                       P4 = Trim(P4) & "   "
              End If
              change_mony = Trim(P4) & Trim(P3) & Trim(P2) & Trim(P1)
    End If
End Function

Private Function harf(mony2 As Long) As String
    Dim S As String, S1 As String
    Dim s2 As String, s3 As String
    S = Trim(Str(mony2))
    If Len(Trim(Str(mony2))) = 1 Then S = "00" & Trim(Str(mony2))
    If Len(Trim(Str(mony2))) = 2 Then S = "0" & Trim(Str(mony2))
    Select Case Left(Trim(S), 1)
           Case 0
                 S1 = ""
           Case 1
                 S1 = " "
           Case 2
                 S1 = " "
           Case 3
                 S1 = ""
           Case 4
                 S1 = ""
           Case 5
                 S1 = ""
           Case 6
                 S1 = ""
           Case 7
                 S1 = ""
           Case 8
                 S1 = ""
           Case 9
                 S1 = ""
    End Select
    Select Case Mid(Trim(S), 2, 1)
           Case 0
                 s2 = ""
           Case 1
                 Select Case Right(Trim(S), 1)
                        Case 0
                             s2 = ""
                        Case 1
                             s2 = ""
                        Case 2
                             s2 = ""
                        Case 3
                             s2 = ""
                        Case 4
                             s2 = ""
                        Case 5
                             s2 = ""
                        Case 6
                             s2 = ""
                        Case 7
                             S1 = ""
                        Case 8
                             S1 = ""
                        Case 9
                             S1 = ""
                  End Select
           Case 2
                 s2 = " "
           Case 3
                 s2 = " "
           Case 4
                 s2 = " "
           Case 5
                 s2 = " "
           Case 6
                 s2 = " "
           Case 7
                 s2 = ""
           Case 8
                 s2 = ""
           Case 9
                 s2 = ""
    End Select
    If Mid(Trim(S), 2, 1) <> 1 Then
        Select Case Right(Trim(S), 1)
               Case 0
                     s3 = ""
               Case 1
                     s3 = ""
               Case 2
                     s3 = ""
               Case 3
                     s3 = ""
               Case 4
                     s3 = ""
               Case 5
                     s3 = ""
               Case 6
                     s3 = ""
               Case 7
                     s3 = ""
               Case 8
                     s3 = ""
               Case 9
                     s3 = ""
        End Select
    End If
    If Trim(S1) <> "" Then S1 = S1 & " "
    If Trim(s2) <> "" Then s2 = s2 & " "
    If Trim(s3) <> "" Then s3 = s3 & " "
    S = S1 & s2 & s3
    If Trim(S) <> "" Then harf = Left(Trim(S), (Len(Trim(S)) - 1)) Else harf = ""
End Function
